zoukankan      html  css  js  c++  java
  • LeetCode459. Repeated Substring Pattern

    Description

    Given a non-empty string check if it can be constructed by taking a substring of it and appending multiple copies of the substring together. You may assume the given string consists of lowercase English letters only and its length will not exceed 10000.

    Example 1:

    Input: “abab”
    Output: True
    Explanation: It’s the substring “ab” twice.

    Example 2:

    Input: “aba”
    Output: False

    Example 3:

    Input: “abcabcabcabc”
    Output: True
    Explanation: It’s the substring “abc” four times. (And the substring “abcabc” twice.)

    解法一

    思路:循环左移字符串k位与原来的字符串进行比较,(k位是由字符串长度len的因数决定)相等则为true。
    如9因数有1,3,9,因为最大的substring为字符串长度的一半,所以k<=len2

    class Solution {
    public:
        string move(string s, int l) {
            string res = s.substr(l);
            res += s.substr(0,l);
            return res;
        }
    
        bool repeatedSubstringPattern(string s) {
            int len = s.size();
            string str;
            for (int i = 1; i <= len/2; i++) {
                if (len % i == 0) {
                    str = move(s, i);
                    if(str == s) return true;
                }
            }
            return false;
        }
    };

    Submission Details
    107 / 107 test cases passed.
    Status: Accepted
    Runtime: 36 ms

    解法二

    用到KMP算法

    1.Roughly speaking, dp[i+1] stores the maximum number of characters that the string is repeating itself up to position i.
    2.Therefore, if a string repeats a length 5 substring 4 times, then the last entry would be of value 15.
    3.To check if the string is repeating itself, we just need the last entry to be non-zero and str.size() to divide (str.size()-last entry).

    bool repeatedSubstringPattern(string str) {
       int i = 1, j = 0, n = str.size();
       vector<int> dp(n+1,0);
       while( i < str.size() ){
           if( str[i] == str[j] ) dp[++i]=++j;
           else if( j == 0 ) i++;
           else j = dp[j];
       }
       return dp[n]&&dp[n]%(n-dp[n])==0;
    }
  • 相关阅读:
    light oj 1105 规律
    light oj 1071 dp(吃金币升级版)
    light oj 1084 线性dp
    light oj 1079 01背包
    light oj 1068 数位dp
    light oj 1219 树上贪心
    light oj 1057 状压dp TSP
    light oj 1037 状压dp
    矩阵快速幂3 k*n铺方格
    矩阵快速幂2 3*n铺方格
  • 原文地址:https://www.cnblogs.com/yangjiannr/p/7391359.html
Copyright © 2011-2022 走看看